Index: trunk/SophyaPI/PI/pisurfdr.cc
===================================================================
--- trunk/SophyaPI/PI/pisurfdr.cc	(revision 203)
+++ trunk/SophyaPI/PI/pisurfdr.cc	(revision 204)
@@ -13,6 +13,6 @@
   arr->XYfromxy(arr->XSize(),arr->YSize(),mXmax, mYmax);
   if (asxy)  mScy = (mXmax-mXmin)/(mYmax-mYmin);
-  float scm =  ((mXmax-mXmin) > (mYmax-mYmin)) ? (mXmax-mXmin)  : (mYmax-mYmin);
-  int i,j;   float cv;
+  double scm =  ((mXmax-mXmin) > (mYmax-mYmin)) ? (mXmax-mXmin)  : (mYmax-mYmin);
+  int i,j;   double cv;
   mZmin = mZmax = arr->Value(0,0);
   for(i=0; i<arr->XSize(); i++) 
@@ -26,7 +26,7 @@
 //  printf("PISurfaceDrawer::PISurfaceDrawer Min/Max: %g,%g  %g,%g  %g,%g  Sc: %g %g %g \n",
 //          mXmin, mXmax, mYmin, mYmax, mZmin, mZmax, mScx, mScy, mScz);
-  float zmin = mZmin; 
-  float zmax = mZmax;
-  float dzz = (mZmax-mZmin)*0.05;
+  double zmin = mZmin; 
+  double zmax = mZmax;
+  double dzz = (mZmax-mZmin)*0.05;
   mLut = new LUT(zmin-dzz*2, zmax-dzz, 256);
 }
@@ -43,5 +43,5 @@
 {
   if (mArr == NULL)  return;
-  float xmin, xmax, ymin, ymax, zmin, zmax;
+  double xmin, xmax, ymin, ymax, zmin, zmax;
   xmin = mXmin*mScx;  xmax = mXmax*mScx;
   ymin = mYmin*mScy;  ymax = mYmax*mScy;
@@ -50,5 +50,5 @@
 // Distance D = Max(xmax-xmin,ymin-ymax)*2
 // Observateur en O = X+D, Yc+2*D 
-  float D = xmax-xmin;
+  double D = xmax-xmin;
   if (D < (ymax-ymin))  D = ymax-ymin;
   D *= 1.4;
@@ -70,5 +70,5 @@
 
 typedef struct   /*  structures pour trier en ZP les facettes */
-  { double dp;  float zh;  int ij;  } ZPSORT;
+  { double dp;  double zh;  int ij;  } ZPSORT;
 /* Nouvelle-Fonction */
 static int ijzpsort(const void * sp1, const void * sp2)
@@ -96,5 +96,5 @@
 
 /* --Methode-- */
-void PISurfaceDrawer::Draw(PIGraphicUC* g, float xmin, float ymin, float xmax, float ymax)
+void PISurfaceDrawer::Draw(PIGraphicUC* g, double xmin, double ymin, double xmax, double ymax)
 {
 // On trace les axes - En attendant de faire mieux - Reza 8/12/98
@@ -116,9 +116,9 @@
 
   ZPSORT* ijzp = new ZPSORT[xsz*ysz];
-  float* xw = new float[(xsz+1)*(ysz+1)];
-  float* yw = new float[(xsz+1)*(ysz+1)];
-  float* zw = new float[(xsz+1)*(ysz+1)];
-
-  float dx,dy;   // taille du bin 
+  double* xw = new double[(xsz+1)*(ysz+1)];
+  double* yw = new double[(xsz+1)*(ysz+1)];
+  double* zw = new double[(xsz+1)*(ysz+1)];
+
+  double dx,dy;   // taille du bin 
   dx = (mXmax-mXmin)*mScx/xsz; 
   dy = (mYmax-mYmin)*mScy/ysz;
@@ -126,5 +126,5 @@
   int i1,j1;
   int i,j,k,l;
-  float x,y,z,xp,yp,zp;
+  double x,y,z,xp,yp,zp;
 
   k = 0;
Index: trunk/SophyaPI/PI/pisurfdr.h
===================================================================
--- trunk/SophyaPI/PI/pisurfdr.h	(revision 203)
+++ trunk/SophyaPI/PI/pisurfdr.h	(revision 204)
@@ -17,5 +17,5 @@
   virtual void 		UpdateLimits();   // Calcule et change la vue-3D
 
-  virtual void 		Draw(PIGraphicUC* g, float xmin, float ymin, float xmax, float ymax); 
+  virtual void 		Draw(PIGraphicUC* g, double xmin, double ymin, double xmax, double ymax); 
   virtual void       	DrawAxes(PIGraphicUC* g);
 
@@ -23,8 +23,8 @@
   P2DArrayAdapter* mArr;
   bool mAda;
-  float mScz, mScx, mScy;
-  float mXmin, mXmax;
-  float mYmin, mYmax;
-  float mZmin, mZmax;
+  double mScz, mScx, mScy;
+  double mXmin, mXmax;
+  double mYmin, mYmax;
+  double mZmin, mZmax;
   LUT* mLut;
 };
Index: trunk/SophyaPI/PI/piwdggen.cc
===================================================================
--- trunk/SophyaPI/PI/piwdggen.cc	(revision 203)
+++ trunk/SophyaPI/PI/piwdggen.cc	(revision 204)
@@ -254,7 +254,7 @@
 
 if (!psf) return;
-psf->NewBloc((float)ofx+XPos(), (float)ofy+YPos(), (float)XSize(), (float)YSize(),
-             (float)XSize(), (float)YSize());
-psf->DrawBox(0., 0., (float)XSize(), (float)YSize());
+psf->NewBloc((double)ofx+XPos(), (double)ofy+YPos(), (double)XSize(), (double)YSize(),
+             (double)XSize(), (double)YSize());
+psf->DrawBox(0., 0., (double)XSize(), (double)YSize());
 sprintf(str,"PIWdgGen::PSPrint() Kind=%ld Name= %s", kind(), Nom().c_str());
 psf->DrawString(12., 12., str, PI_Black, PI_RomanFont, 10);
Index: trunk/SophyaPI/PI/piwdgx.cc
===================================================================
--- trunk/SophyaPI/PI/piwdgx.cc	(revision 203)
+++ trunk/SophyaPI/PI/piwdgx.cc	(revision 204)
@@ -195,5 +195,13 @@
 UnManage();
 if (curselwdg == this)  { SelectionLost(); curselwdg = NULL; }
-if (!sdw)  XtDestroyWidget(sdw);
+if (sdw)  { 
+// Pour gerer la double structure en Widget des PIWindowX
+  if (wmis == k_wmi_normal) XtDestroyWidget(sdw);
+  else if (wmis == k_wmi_cascade) { 
+    SysDWdg pwdg = XtParent(sdw);
+    XtDestroyWidget(sdw);
+    if (pwdg) XtDestroyWidget(pwdg);
+    }
+  }
 }
 
Index: trunk/SophyaPI/PI/piwdgx.h
===================================================================
--- trunk/SophyaPI/PI/piwdgx.h	(revision 203)
+++ trunk/SophyaPI/PI/piwdgx.h	(revision 204)
@@ -15,9 +15,4 @@
 typedef WidgetClass SysDWdgClass;
 
-
-enum WmIntState { k_wmi_unknown=0,
-                  k_wmi_normal=1, k_wmi_toplevel=2, 
-                  k_wmi_transient=3, k_wmi_override=4,
-                  k_wmi_appshell=5 };
 
 class PIWdgX : public PIWdgGen 
@@ -95,4 +90,11 @@
 
 protected:
+// Definit le type de Widget, en particulier pour la gestion des feneteres de haut niveau
+// k_wmi_cascade : Widget cree en cascade d'un autre (Exemple pour PIWIndowX)
+  enum WmIntState { k_wmi_unknown=0,
+                    k_wmi_normal=1, k_wmi_toplevel=2, 
+                    k_wmi_transient=3, k_wmi_override=4,
+                    k_wmi_appshell=5, k_wmi_cascade=6 };
+
   int 		InitXt(int narg=0, char *arg[]=NULL); 
 
Index: trunk/SophyaPI/PI/piwindowx.cc
===================================================================
--- trunk/SophyaPI/PI/piwindowx.cc	(revision 203)
+++ trunk/SophyaPI/PI/piwindowx.cc	(revision 204)
@@ -92,4 +92,5 @@
 
 CreateXtWdg(nom, xmFormWidgetClass, pwm->XtWdg(), sx, sy, 0, 0);
+wmis = k_wmi_cascade;
 }
 
@@ -97,4 +98,5 @@
 PIWindowX::~PIWindowX()
 {
+Hide();
 delete pwm;
 }
Index: trunk/SophyaPI/PI/psfile.cc
===================================================================
--- trunk/SophyaPI/PI/psfile.cc	(revision 203)
+++ trunk/SophyaPI/PI/psfile.cc	(revision 204)
@@ -243,6 +243,6 @@
 /* Dimensions des divers formats */
   struct PaperSize {
-      float width ;
-      float height ;
+      double width ;
+      double height ;
   };
 struct PaperSize PaperSizeTable[] = {
@@ -254,5 +254,5 @@
 
 
-float cm2pt(float x);
+double cm2pt(double x);
 
 
@@ -278,9 +278,9 @@
 //--
 //++
-// PSFile (const char * FileName, float sc = 1.0)
+// PSFile (const char * FileName, double sc = 1.0)
 //	Créateur pour fichier Encapsulated Postscript
 // PSFile (const char * FileName, PIOrientation orientation, -
 //         PIPaperSize paperSize= PI_A4, -
-//         float marginX = 5.0, float marginY = 5.0 )
+//         double marginX = 5.0, double marginY = 5.0 )
 //	Créateur pour fichier Postscript
 //--
@@ -294,5 +294,5 @@
  *
  */
-PSFile::PSFile(const char * FileName, float sc) 
+PSFile::PSFile(const char * FileName, double sc) 
 #if defined(__DECCXX) || defined(__KCC__) || defined(__aCC__)
     : mPSFileName(FileName==NULL? "unnamed.eps" : const_cast<char *>(FileName)),
@@ -359,5 +359,5 @@
 	       PIOrientation orientation,
 	       PIPaperSize   paperSize,
-	       float marginX, float marginY)
+	       double marginX, double marginY)
 #if defined(__DECCXX) || defined(__KCC__) || defined(__aCC__)
  :  mPSFileName (FileName == NULL ? "unnamed.ps" : const_cast<char *>(FileName)),
@@ -471,7 +471,7 @@
 }
 
-void  PSFile::NewPage(float Dx, float Dy, PIOrientation orientation) {
-
-float  tw, th; /* largeur & hauteur corrigees des marges */
+void  PSFile::NewPage(double Dx, double Dy, PIOrientation orientation) {
+
+double  tw, th; /* largeur & hauteur corrigees des marges */
 
     /* On ferme ce qui doit l'etre ... */
@@ -635,6 +635,6 @@
 
 
-void  PSFile::NewBloc(float x0, float y0, float Tx, float Ty,
-			      float Dx, float Dy){
+void  PSFile::NewBloc(double x0, double y0, double Tx, double Ty,
+			      double Dx, double Dy){
 
     /* Si pas de page, on s'en va */
@@ -692,7 +692,7 @@
   PIColor tmp = cmap.GetColor(cid) ; 
   fprintf(mPSFile, "/ur %.3f def /ug %.3f def /ub %.3f def \n", 
-          (float)(tmp.red)/65535., 
-          (float)(tmp.green)/65535., 
-          (float)(tmp.blue)/65535.) ; 
+          (double)(tmp.red)/65535., 
+          (double)(tmp.green)/65535., 
+          (double)(tmp.blue)/65535.) ; 
 }
 
@@ -704,5 +704,5 @@
 
 
-void  PSFile::DrawString  (float x,  float y, const char *s, 
+void  PSFile::DrawString  (double x,  double y, const char *s, 
 			   PIColors DrawColor, 
 			   PIFontAtt FontAtt, 
@@ -730,5 +730,5 @@
 
 
-void  PSFile::DrawLine    (float x1, float y1, float x2, float y2, 
+void  PSFile::DrawLine    (double x1, double y1, double x2, double y2, 
 		   PIColors DrawColor,
 		   PILineAtt LineAtt) {
@@ -769,5 +769,5 @@
 
 
-void  PSFile::DrawBox(float x0, float y0, float Tx, float Ty, 
+void  PSFile::DrawBox(double x0, double y0, double Tx, double Ty, 
 		      PIColors  DrawColor,
 		      PILineAtt LineAtt) {
@@ -791,5 +791,5 @@
 
 
-void  PSFile::DrawFBox(float x0, float y0, float Tx, float Ty, 
+void  PSFile::DrawFBox(double x0, double y0, double Tx, double Ty, 
 		   PIColors DrawColor,
 		   PIColors FillColor, 
@@ -818,5 +818,5 @@
 
 
-void  PSFile::DrawCircle  (float x0, float y0, float r, 
+void  PSFile::DrawCircle  (double x0, double y0, double r, 
 			   PIColors DrawColor,
 			   PILineAtt LineAtt) {
@@ -840,5 +840,5 @@
 
 
-void  PSFile::DrawFCircle (float x0, float y0, float r,
+void  PSFile::DrawFCircle (double x0, double y0, double r,
 		   PIColors DrawColor,
 		   PIColors FillColor, 
@@ -872,5 +872,5 @@
 
 // Les coordonnees sont supposees etre en mode incremental .
-void  PSFile::DrawPolygon (float *x, float *y, int n,
+void  PSFile::DrawPolygon (double *x, double *y, int n,
 		   PIColors DrawColor, 
 		   PILineAtt LineAtt, bool cinc) {
@@ -901,5 +901,5 @@
 
 
-void  PSFile::DrawFPolygon(float *x, float *y, int n,
+void  PSFile::DrawFPolygon(double *x, double *y, int n,
 		   PIColors DrawColor,
 		   PIColors FillColor,
@@ -938,5 +938,5 @@
 
 
-void  PSFile::DrawMarker  (float x0, float y0,
+void  PSFile::DrawMarker  (double x0, double y0,
 			   PIMarker MrkType,   
 			   PIColors DrawColor,
@@ -965,5 +965,5 @@
  *
  */
-void  PSFile::DrawMarkers (float *x0, float *y0, int n,
+void  PSFile::DrawMarkers (double *x0, double *y0, int n,
 			   PIMarker MrkType,
 			   PIColors DrawColor,
@@ -989,5 +989,5 @@
 }
 
-void PSFile::Image(float x0, float y0, float Tx, float Ty,
+void PSFile::Image(double x0, double y0, double Tx, double Ty,
 		   int Nx, int Ny,
 		   unsigned char *Pict, 
@@ -1034,5 +1034,5 @@
  */
 
-float cm2pt(float x) {
+double cm2pt(double x) {
     return (x*28.35);
 }
Index: trunk/SophyaPI/PI/psfile.h
===================================================================
--- trunk/SophyaPI/PI/psfile.h	(revision 203)
+++ trunk/SophyaPI/PI/psfile.h	(revision 204)
@@ -51,10 +51,10 @@
 /* Valable pour une page, ou un bloc */
 /*typedef struct {
- *  float X0;          Coordonnes sommet NO  
- *  float Y0;           en unites courantes  
- *  float Tx;          Format                
- *  float Ty;           en unites courantes  
- *  float Dx;          Coord sommet SE       
- *  float Dy;           en unites courantes  
+ *  double X0;          Coordonnes sommet NO  
+ *  double Y0;           en unites courantes  
+ *  double Tx;          Format                
+ *  double Ty;           en unites courantes  
+ *  double Dx;          Coord sommet SE       
+ *  double Dy;           en unites courantes  
  *  int orientation;   LANDSCAPE OU PORTRAIT 
  *} Format;
@@ -75,9 +75,9 @@
 public:
     /* Production fichier eps */
-    PSFile (const char * FileName, float sc = 1.0);
+    PSFile (const char * FileName, double sc = 1.0);
     /* Production fichier ps  */
     PSFile (const char * FileName, PIOrientation orientation, 
 	    PIPaperSize paperSize= PI_A4, 
-	    float marginX = 5.0, float marginY = 5.0 ) ;
+	    double marginX = 5.0, double marginY = 5.0 ) ;
 
     virtual      ~PSFile();
@@ -96,8 +96,8 @@
     virtual PIMarker    GetMarker();
 
-    virtual void  NewPage(float Dx, float Dy, PIOrientation orientation);
+    virtual void  NewPage(double Dx, double Dy, PIOrientation orientation);
     virtual void  EndPage();
-    virtual void  NewBloc(float x0, float y0, float Tx, float Ty,
-			  float Dx, float Dy);
+    virtual void  NewBloc(double x0, double y0, double Tx, double Ty,
+			  double Dx, double Dy);
     virtual void  EndBloc();
 
@@ -106,44 +106,44 @@
 
     /* Trace */
-    virtual void  DrawString  (float x,  float y, const char *s, 
+    virtual void  DrawString  (double x,  double y, const char *s, 
 			       PIColors DrawColor  = PI_NotDefColor, 
 			       PIFontAtt FontAtt   = PI_NotDefFontAtt, 
 			       int FontSize        = 8);
-    virtual void  DrawLine    (float x1, float y1, float x2, float y2, 
-			       PIColors DrawColor  = PI_NotDefColor,
-			       PILineAtt LineAtt   = PI_NotDefLineAtt);
-    virtual void  DrawBox     (float x0, float y0, float Tx, float Ty, 
-			       PIColors DrawColor  = PI_NotDefColor,
-			       PILineAtt LineAtt   = PI_NotDefLineAtt);
-    virtual void  DrawFBox    (float x0, float y0, float Tx, float Ty, 
+    virtual void  DrawLine    (double x1, double y1, double x2, double y2, 
+			       PIColors DrawColor  = PI_NotDefColor,
+			       PILineAtt LineAtt   = PI_NotDefLineAtt);
+    virtual void  DrawBox     (double x0, double y0, double Tx, double Ty, 
+			       PIColors DrawColor  = PI_NotDefColor,
+			       PILineAtt LineAtt   = PI_NotDefLineAtt);
+    virtual void  DrawFBox    (double x0, double y0, double Tx, double Ty, 
 			       PIColors DrawColor  = PI_NotDefColor,
 			       PIColors FillColor  = PI_NotDefColor, 
 			       PILineAtt LineAtt   = PI_NotDefLineAtt);
-    virtual void  DrawCircle  (float x0, float y0, float r, 
-			       PIColors DrawColor  = PI_NotDefColor,
-			       PILineAtt LineAtt   = PI_NotDefLineAtt);
-    virtual void  DrawFCircle (float x0, float y0, float r,
+    virtual void  DrawCircle  (double x0, double y0, double r, 
+			       PIColors DrawColor  = PI_NotDefColor,
+			       PILineAtt LineAtt   = PI_NotDefLineAtt);
+    virtual void  DrawFCircle (double x0, double y0, double r,
 			       PIColors DrawColor  = PI_NotDefColor,
 			       PIColors FillColor  = PI_NotDefColor, 
 			       PILineAtt LineAtt   = PI_NotDefLineAtt);
-    virtual void  DrawPolygon (float *x, float *y, int n,
+    virtual void  DrawPolygon (double *x, double *y, int n,
 			       PIColors DrawColor  = PI_NotDefColor, 
 			       PILineAtt LineAtt   = PI_NotDefLineAtt, 
                                bool cinc = true);
-    virtual void  DrawFPolygon(float *x, float *y, int n,
+    virtual void  DrawFPolygon(double *x, double *y, int n,
 			       PIColors DrawColor  = PI_NotDefColor,
 			       PIColors FillColor  = PI_NotDefColor,
 			       PILineAtt LineAtt   = PI_NotDefLineAtt, 
                                bool cinc = true);
-    virtual void  DrawMarker  (float x0, float y0, 
+    virtual void  DrawMarker  (double x0, double y0, 
 			       PIMarker MrkType    = PI_NotDefMarker, 
 			       PIColors DrawColor  = PI_NotDefColor,
 			       int MarkerSize=14);
-    virtual void  DrawMarkers (float *x0, float *y0, int n,
+    virtual void  DrawMarkers (double *x0, double *y0, int n,
 			       PIMarker MrkType    = PI_NotDefMarker,
 			       PIColors DrawColor  = PI_NotDefColor,
 			       int MarkerSize=14); 
 
-    virtual void  Image(float x0, float y0, float Tx, float Ty,
+    virtual void  Image(double x0, double y0, double Tx, double Ty,
 			int Nx, int Ny,
 			unsigned char *pict,
@@ -155,7 +155,7 @@
 	int    num;
 	char*  label;
-	float  X0, Y0;            /* coordonnees sommet NO */
-	float  Tx, Ty;            /* Format */
-	float  Dx, Dy;            /* Repere utilisateur */
+	double  X0, Y0;            /* coordonnees sommet NO */
+	double  Tx, Ty;            /* Format */
+	double  Dx, Dy;            /* Repere utilisateur */
 	long  begin,end,tmp;   /* offsets dans le fichier */
     } Bloc ;
@@ -167,5 +167,5 @@
 	int num;
 	int BlocCounter;
-	float Dx,Dy;              /* Sommet SE (unites utilisateur) */ 
+	double Dx,Dy;              /* Sommet SE (unites utilisateur) */ 
 	PIOrientation orientation;
 	long  begin, end, tmp;    /* Offsets dans le fichier */
@@ -179,9 +179,9 @@
     FILE *   mPSFile;
     const char *   mPSFileName;
-    float    Tw,Th ;              /* Format, en cm */
-    float    WMargin,HMargin ;    /* Marges minimales */
+    double    Tw,Th ;              /* Format, en cm */
+    double    WMargin,HMargin ;    /* Marges minimales */
     int      isEPS;               /* Vrai si PostScript Encapsule */
     long     boundingBox;         /* Endroit ou est specifiee la bb */
-    float    scale;               /* boundingbox = Dx*scale ; Dy*scale */
+    double    scale;              /* boundingbox = Dx*scale ; Dy*scale */
     PIPaperSize mPaperSize ; 
     int      PageCounter;         /* nbr pages */
